/// <reference types="react" />
import { DefaultProps, RenditionSystemProps, Sizing, Theme } from '../common-types';
export interface InternalInputProps extends DefaultProps, Sizing {
    monospace?: boolean;
    autoComplete?: string;
    autoFocus?: boolean;
    disabled?: boolean;
    form?: string;
    max?: number | string;
    maxLength?: number;
    min?: number | string;
    minLength?: number;
    name?: string;
    placeholder?: string;
    readOnly?: boolean;
    required?: boolean;
    type?: string;
    value?: string | string[] | number;
    pattern?: string;
    invalid?: boolean;
    valid?: boolean;
    onChange?: React.ChangeEventHandler<HTMLInputElement>;
}
export interface ThemedInputProps extends InternalInputProps {
    theme: Theme;
}
export declare type InputProps = InternalInputProps & RenditionSystemProps;
declare const _default: import("react").ForwardRefExoticComponent<InternalInputProps & import("../common-types").Tooltip & import("../common-types").StyledSystemProps & import("react").RefAttributes<HTMLInputElement>>;
export default _default;
