import * as React from 'react';
import { DefaultProps, RenditionSystemProps, Theme } from '../common-types';
export declare const whitespace: (props: ThemedTxtProps) => string | null;
export declare const caps: (props: ThemedTxtProps) => "text-transform: uppercase, letterSpacing: 0.2em" | null;
export declare const bold: (props: ThemedTxtProps) => string | null;
export declare const align: {
    [cssProp: string]: string;
};
declare const Base: React.FunctionComponent<TxtProps> & {
    p: React.FunctionComponent<TxtProps>;
    span: React.FunctionComponent<TxtProps>;
};
export declare type Whitespace = 'normal' | 'nowrap' | 'pre' | 'pre-line' | 'pre-wrap' | 'initial' | 'inherit';
export declare type Align = 'left' | 'right' | 'center' | 'justify' | 'justify-all' | 'start' | 'end' | 'match-parent' | 'inherit' | 'initial' | 'unset';
export interface InternalTxtProps extends DefaultProps {
    monospace?: boolean;
    bold?: boolean;
    caps?: boolean;
    whitespace?: Whitespace;
    align?: Align;
}
export interface ThemedTxtProps extends InternalTxtProps {
    theme: Theme;
}
export declare type TxtProps = InternalTxtProps & RenditionSystemProps;
export default Base;
