import * as tslib_1 from "tslib";
import { Button } from 'grommet';
import * as React from 'react';
import styled from 'styled-components';
import asRendition from '../asRendition';
import { getColor, getColoringType, isLight, px } from '../utils';
var getHoverEffectOverride = function (bg, color, opacity) {
    return "\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\tsvg {\n\t\t\t\tcolor: " + color + " !important;\n\t\t\t}\n\n\t\t\tbox-shadow: none;\n\t\t\tbackground: " + bg + ";\n\t\t\tborder-color: " + bg + ";\n\t\t\tcolor: " + color + ";\n\t\t\topacity: " + opacity + ";\n\t\t}\n\t";
};
var ButtonBase = styled(Button)(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n\tfont-family: ", ";\n\tfont-weight: ", ";\n\tfont-size: ", ";\n\theight: ", ";\n\twhite-space: nowrap;\n\tsvg {\n\t\tcolor: inherit !important;\n\t\tfont-size: 0.875em;\n\t}\n\t/* These rules cause consistent styling when the button is rendered as a link */\n\tdisplay: inline-flex;\n\talign-items: center;\n\tjustify-content: center;\n\n\t&:disabled {\n\t\tcursor: not-allowed;\n\t}\n"], ["\n\tfont-family: ", ";\n\tfont-weight: ", ";\n\tfont-size: ", ";\n\theight: ", ";\n\twhite-space: nowrap;\n\tsvg {\n\t\tcolor: inherit !important;\n\t\tfont-size: 0.875em;\n\t}\n\t/* These rules cause consistent styling when the button is rendered as a link */\n\tdisplay: inline-flex;\n\talign-items: center;\n\tjustify-content: center;\n\n\t&:disabled {\n\t\tcursor: not-allowed;\n\t}\n"])), function (props) { return props.theme.titleFont; }, function (props) { return props.theme.button.font.weight; }, function (props) { return px(props.theme.fontSizes[1]); }, function (props) { return props.theme.button.height; });
var ColouredButton = styled(ButtonBase)(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n\tcolor: ", ";\n\t", ";\n"], ["\n\tcolor: ",
    ";\n\t",
    ";\n"])), function (props) {
    return isLight(getColor(props, 'color', 'main'))
        ? props.theme.colors.text.main
        : 'white';
}, function (props) {
    var color = getColor(props, 'color', 'dark');
    return getHoverEffectOverride(color, isLight(color) ? props.theme.colors.text.main : 'white');
});
var Outline = styled(ButtonBase)(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n\tcolor: ", ";\n\tborder-color: ", ";\n\tsvg {\n\t\tcolor: ", " !important;\n\t}\n\t", ";\n"], ["\n\tcolor: ", ";\n\tborder-color: ", ";\n\tsvg {\n\t\tcolor: ", " !important;\n\t}\n\t",
    ";\n"])), function (props) { return props.theme.colors.text.main; }, function (props) { return props.color || props.theme.colors.text.main; }, function (props) { return props.theme.colors.tertiary.main; }, function (props) {
    return getHoverEffectOverride(props.color || props.theme.colors.text.main, isLight(props.color) ? props.theme.colors.text.main : 'white');
});
var Light = styled(ButtonBase)(templateObject_4 || (templateObject_4 = tslib_1.__makeTemplateObject(["\n\tcolor: ", ";\n\tborder-color: ", ";\n\tbackground: white;\n\tborder: none;\n\t", ";\n\n\t&:disabled {\n\t\topacity: 1;\n\t\tcolor: #c6c8c9;\n\t}\n"], ["\n\tcolor: ", ";\n\tborder-color: ", ";\n\tbackground: white;\n\tborder: none;\n\t",
    ";\n\n\t&:disabled {\n\t\topacity: 1;\n\t\tcolor: #c6c8c9;\n\t}\n"])), function (props) { return props.theme.colors.text.main; }, function (props) { return props.theme.colors.text.main; }, function (props) {
    return getHoverEffectOverride('white', props.theme.colors.secondary.main, '0.9');
});
var LightOutline = styled(Light)(templateObject_5 || (templateObject_5 = tslib_1.__makeTemplateObject(["\n\tcolor: white;\n\tborder: 1px solid white;\n\tbackground: transparent;\n\t", ";\n\n\t&:disabled {\n\t\topacity: 1;\n\t\tcolor: #c6c8c9;\n\t}\n"], ["\n\tcolor: white;\n\tborder: 1px solid white;\n\tbackground: transparent;\n\t",
    ";\n\n\t&:disabled {\n\t\topacity: 1;\n\t\tcolor: #c6c8c9;\n\t}\n"])), function (props) {
    return getHoverEffectOverride('white', props.theme.colors.secondary.main, '0.9');
});
var Plain = styled(ButtonBase)(templateObject_6 || (templateObject_6 = tslib_1.__makeTemplateObject(["\n\tcolor: ", ";\n\theight: auto;\n\tfont-weight: ", ";\n\tborder-radius: 0;\n\t", ";\n"], ["\n\tcolor: ", ";\n\theight: auto;\n\tfont-weight: ", ";\n\tborder-radius: 0;\n\t",
    ";\n"])), function (props) { return props.color || props.theme.colors.text.main; }, function (props) { return props.theme.button.font.weight; }, function (props) {
    return getHoverEffectOverride('none', props.hoverColor || props.theme.colors.text.light);
});
var underlineButtonActiveStyles = function (props) { return "\n\tcolor: " + (props.color || props.theme.colors.text.main) + ";\n\tbackground: none;\n\tbox-shadow: 0px -1px 0 0px inset;\n"; };
var Underline = styled(Plain)(templateObject_7 || (templateObject_7 = tslib_1.__makeTemplateObject(["\n\t", "\n\tborder-bottom: 1px solid;\n\tbackground: none;\n\t&:hover:enabled,\n\t&:focus:enabled,\n\t&:active:enabled {\n\t\t", ";\n\t}\n"], ["\n\t", "\n\tborder-bottom: 1px solid;\n\tbackground: none;\n\t&:hover:enabled,\n\t&:focus:enabled,\n\t&:active:enabled {\n\t\t", ";\n\t}\n"])), function (props) { return (props.active ? underlineButtonActiveStyles(props) : ''); }, underlineButtonActiveStyles);
var getStyledButton = function (_a, isPrimary) {
    var outline = _a.outline, underline = _a.underline, plain = _a.plain, active = _a.active, light = _a.light, originalProps = tslib_1.__rest(_a, ["outline", "underline", "plain", "active", "light"]);
    if (plain) {
        return function (props) { return (React.createElement(Plain, tslib_1.__assign({}, props, { color: getColor(originalProps, 'color', 'main'), hoverColor: getColor(originalProps, 'color', 'light') }))); };
    }
    if (light) {
        if (outline) {
            return LightOutline;
        }
        return Light;
    }
    if (underline) {
        return function (props) { return (React.createElement(Underline, tslib_1.__assign({}, props, { plain: true, color: getColor(originalProps, 'color', 'main') }))); };
    }
    if ((outline && !active) || !isPrimary) {
        return function (props) { return (React.createElement(Outline, tslib_1.__assign({}, props, { color: getColor(originalProps, 'color', 'main') }))); };
    }
    return ColouredButton;
};
var Base = function (props) {
    var outline = props.outline, underline = props.underline, children = props.children, label = props.label, primary = props.primary, color = props.color, plain = props.plain, active = props.active, light = props.light, restProps = tslib_1.__rest(props, ["outline", "underline", "children", "label", "primary", "color", "plain", "active", "light"]);
    var basePrimary = !!props.bg ||
        (!!getColoringType(props) && !outline && !underline && !props.plain);
    var baseColor = props.bg || getColor(props, 'bg', 'main');
    var secondary = baseColor ? false : true;
    baseColor = baseColor || props.theme.colors.secondary.main;
    if (active) {
        basePrimary = !basePrimary;
    }
    var StyledButton = getStyledButton(tslib_1.__assign({ secondary: secondary }, props), basePrimary);
    return (React.createElement(StyledButton, tslib_1.__assign({ primary: basePrimary, color: baseColor, active: active && (underline || plain) }, restProps, { plain: !!plain || !!underline, label: label || children })));
};
export default asRendition(Base, [], ['width', 'color', 'bg']);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7;
