import * as tslib_1 from "tslib";
import * as React from 'react';
import { Input } from '../../../../';
var BaseInput = function (props) {
    var value = props.value, readonly = props.readonly, disabled = props.disabled, autofocus = props.autofocus, onBlur = props.onBlur, onFocus = props.onFocus, options = props.options, schema = props.schema, formContext = props.formContext, inputProps = tslib_1.__rest(props, ["value", "readonly", "disabled", "autofocus", "onBlur", "onFocus", "options", "schema", "formContext"]);
    if (schema.type === 'number') {
        inputProps.type = 'number';
    }
    else {
        inputProps.type = options.inputType || inputProps.type || 'text';
    }
    var change = function (_a) {
        var value = _a.target.value;
        return props.onChange(value === '' ? options.emptyValue : value);
    };
    return (React.createElement(Input, tslib_1.__assign({ width: "100%", readOnly: readonly, disabled: disabled, autoFocus: autofocus, value: value == null ? '' : value }, inputProps, { onChange: change, onBlur: onBlur && (function (event) { return onBlur(inputProps.id, event.target.value); }), onFocus: onFocus && (function (event) { return onFocus(inputProps.id, event.target.value); }) })));
};
export default BaseInput;
